Function.prototype.memoized = function() {
  var originalFunction = this;
  
  var table = {};
  
  var generateKey = function(args) {
    return JSON.stringify(args);
  }
  
  return function() {
    var key = generateKey(arguments);
    
    if(table[key] === undefined) {
      table[key] = originalFunction.apply(this, arguments);
    }
    return table[key];
  }
}

var start = new Date().getTime();

var fib = function(n) {
  if (n < 2)
    return 1;
  else
    return fib(n - 1) + fib(n - 2);
}.memoized();

console.log(fib(400));

var end = new Date().getTime();

console.log((end - start)/1000.0);